#!/usr/bin/perl

# create a file like:
#
#   {alloc,free}  edst spi proto src algo enckey authkey
#
# from pseudo-random data.

$operationCount=0;
$maxOperations=8192;

srand(19710421); # keep it pseudo-random, repeatable for now

&init_stuff;

$saCount=0;

@edst=();
@spi=();
$proto="esp";
$src="192.1.2.23";


while($operationCount < $maxOperations) {
  $operationCount++;

  # pick a random operation.

  $op=rand(4);

  if($op < 1 && $saCount > 0) {
    # generate a free with probability 25%, if there are any to free
    # pick an SA to free.
    
    $sanum=rand($saCount);
    $edst=$edst[$sanum];
    $spi=$spi[$sanum];
    
    print "free $edst $spi $proto $src\n";
      
    if($sanum != $saCount-1) {
      # delete it, by copying one from end.
      $edst[$sanum]=$edst[$saCount-1];
      $spi[$sanum]=$spi[$saCount-1];
    }
    $saCount--;
  } else {
    # make a new one.

    $choice=int(rand(100));
    $edst=$edst_choices[$choice];
    $spi="0x".(int(rand(16777216))+1024);

    print "alloc $edst $spi $proto $src\n";

    $edst[$saCount]=$edst;
    $spi[$saCount]=$spi;

    $saCount++;
  }
}


sub init_stuff {
  # make up 100 random edst's

  for($i=0; $i<100; $i++) {
    $a=int(rand(256)); $b=int(rand(256)); $c=int(rand(256)); $d=int(rand(256));
    $edst_choices[$i]="$a.$b.$c.$d";
  }
}
